.\"     Title: l3
.\"    Author: 
.\" Generator: DocBook XSL Stylesheets v1.72.0 <http://docbook.sf.net/>
.\"      Date: 01/16/2008
.\"    Manual: 
.\"    Source: 
.\"
.TH "L3" "1" "01/16/2008" "" ""
.\" disable hyphenation
.nh
.\" disable justification (adjust text to left margin only)
.ad l
.SH "NAME"
l3 \- interpret l3 programs
.SH "SYNOPSIS"
\fIl3\fR [\-f FILE] [\-l STATE_LOAD] [\-s STATE_SAVE] [\-i] [\-d] [\-h]
.sp
.SH "DESCRIPTION"
The l3(1) command executes l3lang(1) scripts in files and provides an interactive toplevel for expression evaluation via \fB\-i\fR.
.sp
This command\-line version is best used for unattended execution; to fully use l3 requires the graphical interface; see l3gui(1).
.sp
.SS "Batch mode"
When a FILE argument is present (\-f), the FILE is executed. Execution continues until the end\-of\-file is reached, or an error is encountered. In both cases a state file is produced (either FILE.l3s, or STATE_SAVE from \-s) along with whatever output FILE produced.
.sp
When a STATE_LOAD argument is given (\-l), the state is loaded. This implicitly loads the script FILE that originally produced STATE_LOAD. Then, this original script is scanned and \fBnew\fR expressions are executed. Expressions previously executed successfully are \fBnot\fR executed again. The final state is written back to STATE_LOAD, or STATE_SAVE if \-s was given.
.sp
.SS "Interactive mode"
When \-i is given, any files specified are executed first, and the toplevel started after. If any error occurs, the error is printed and the toplevel is entered immediately, even if unread files remain.
.sp
Expressions entered at the toplevel are executed immediately. The expressions are appended to the current FILE if present, otherwise they form a new script. On end\-of\-file, the the state is saved in one of STATE_SAVE, STATE_LOAD, FILE.l3s, or st.l3s (in that order), and the interpreter exits.
.sp
Errors simply cause a return to the toplevel.
.sp
.SH "OPTIONS"
.PP
\-\-help, \-h
.RS 4
Print help and exit.
.RE
.PP
\-\-version
.RS 4
show program's version number and exit
.RE
.PP
\-h, \-\-help
.RS 4
show this help message and exit
.RE
.PP
\-f FILE, \-\-file=FILE
.RS 4
Execute this script in l3.
.RE
.PP
\-l STATE_LOAD, \-\-state_load=STATE_LOAD
.RS 4
Start l3 from this state file.
.RE
.PP
\-s STATE_SAVE, \-\-state_save=STATE_SAVE
.RS 4
Save l3 state to this file.
.RE
.PP
\-i, \-\-interactive
.RS 4
Go to Python console on exit. This allows moving between Python and l3. To restart, use l3.run()
.RE
.PP
\-d, \-\-developer
.RS 4
Import all l3 modules (from \&... import *) when using \-i. Allows for interactive Python code updates.
.RE
.SH "ENVIRONMENT"
L3HOME The path to the l3 installation root.
.sp
.SH "SEE ALSO"
l3lang(1), l3gui(1).
.sp
.SH "AUTHOR"
Michael Hohn, mhhohn@users.sf.net
.sp
.SH "COPYING"
Copyright \(co 2004\-8, 2006 Lawrence Berkeley National Laboratory
.sp
l3 is released under the BSD license. See license.txt for details.
.sp
.SH "REFERENCES"
.IP " 1." 4
l3(1)
.RS 4
\%l3.html
.RE
.IP " 2." 4
l3lang(1)
.RS 4
\%l3lang.html
.RE
.IP " 3." 4
l3gui(1)
.RS 4
\%l3gui.html
.RE
